﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.IO;
using System.Windows.Browser;
using SilverlightMenu.Library;

namespace FileUploadInSilverlight
{
    public partial class MainPage : UserControl
    {
        //int menuIndex = 1;
        public MainPage()
        {
            InitializeComponent();
            btnBrowse.Click += new RoutedEventHandler(btnBrowse_Click);
            btnNext.Click += new RoutedEventHandler(btnNext_Click);
            Loaded += (s, e) =>
            {
                HtmlPage.Plugin.Focus();
                txt.Focus();
            };
        }
        private void Menu_MenuItemClicked(object sender, EventArgs e)
        {
            var clickedItem = (MenuItem)sender;

            //if (clickedItem.IsCheckable)
            //    MessageBox.Show(string.Format("{0} is now {1}", clickedItem.Name, clickedItem.IsChecked ? "CHECKED" : "UNCHECKED"));
            //else
            MessageBox.Show(string.Format("You clicked: {0}", clickedItem.Text));

            //switch (clickedItem.Name)
            //{
            //    case "mnuOpenProject":
            //        var newMenuItem = new MenuItem()
            //        {
            //            Name = string.Format("Item{0}", menuIndex),
            //            Text = string.Format("{0} Item {0}", menuIndex)
            //        };
            //        menuIndex++;
            //        mnuTop.AddMenuItem(clickedItem, newMenuItem);
            //        break;
            //}
        }
        void btnNext_Click(object sender, RoutedEventArgs e)
        {
            App app = (App)Application.Current;
            app.GotoPage(new NextPage());
        }

        void btnBrowse_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog dlg = new OpenFileDialog();
            dlg.Multiselect = false;
            dlg.Filter = "All files (*.*)|*.*|PNG Images (*.png)|*.png";

            bool? retval = dlg.ShowDialog();
            busyIndicator.IsBusy = true;
            if (retval != null && retval == true)
            {
                UploadFile(dlg.File.Name, dlg.File.OpenRead());
                txtFile.Text = dlg.File.Name;
            }
            else
            {
                txtFile.Text = "No file selected...";
                busyIndicator.IsBusy = false;
            }
        }

        private void UploadFile(string fileName, Stream data)
        {
            UriBuilder ub = new UriBuilder("http://localhost:50639/receiver.ashx");
            ub.Query = string.Format("filename={0}", fileName);

            WebClient c = new WebClient();
            c.OpenWriteCompleted += (sender, e) =>
            {
                PushData(data, e.Result);
                e.Result.Close();
                data.Close();
                busyIndicator.IsBusy = false;
            };
            c.OpenWriteAsync(ub.Uri);
        }

        private void PushData(Stream input, Stream output)
        {
            byte[] buffer = new byte[4096];
            int bytesRead;

            while ((bytesRead = input.Read(buffer, 0, buffer.Length)) != 0)
            {
                output.Write(buffer, 0, bytesRead);
            }
        }


    }
}
